#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_GiantSharkLevel.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_GiantSharkLevel> Fish_GiantSharkLevel::msSingleton(nullptr);

int Fish_GiantSharkLevel::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GiantSharkLevelData* Fish_GiantSharkLevel::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_GiantSharkLevelData>& Fish_GiantSharkLevel::GetMapData()
{
	return mMapData;
}

void Fish_GiantSharkLevel::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_GiantSharkLevel::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GiantSharkLevelData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* Level = element->Attribute("Level");
			std::vector<std::string> vecLevel;
			boost::split(vecLevel, Level, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecLevel.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecLevel[i].c_str(), &temp))
				{
					data.mLevel.push_back(temp);
				}
			}
		}
		data.mBasicRewards = element->IntAttribute("BasicRewards");
		data.mBrandProbability = element->IntAttribute("BrandProbability");
		data.mNumberCards = element->IntAttribute("NumberCards");
		data.mIntegralAddition = element->IntAttribute("IntegralAddition");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_GiantSharkLevel::Load()
{
	Load("../Config/Fish_GiantSharkLevel.xml");
}

Fish_GiantSharkLevel* Fish_GiantSharkLevel::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GiantSharkLevel());
	}
	return msSingleton.get();
}
